#include <stdlib.h>
#include <string.h>
#include "c99tree-cc.h"

/* use the true versions in this file so that the original locations are inherited */
#undef c99c_tt_append
#undef C99Nalloc

c99c_node_t *c99c_tt_append(c99tree_cc_t *ctx, c99c_node_type_t type, char *text YLINEARG)
{
	c99c_node_t *n, *nnew, *del_start;

	/* only local tokens will work because of deletion */
	if (!ctx->loc_current->is_local)
		return NULL;

	/* don't write newlines that are not even in the file */
	if (ctx->loc_current->soffs < 0)
		return NULL;

	/* before the first preproc token that reveals the true file name */
	if (ctx->loc_current->cpp_file == NULL)
		return NULL;

	/* c99tree-cpp uses this special file name for -D and friends */
	if (strcmp(ctx->loc_current->cpp_file, "<prinit>") == 0)
		return NULL;


	nnew = C99Nalloc(ctx, type, text, NULL YLINEPARM);
	ctx->loc_current->twin_parent = nnew;
	nnew->loc.twin_parent = NULL;

	if (ctx->TOKT != NULL) {
			/* find the preceding token and delete anything after that (step back, jumping over \n's introduced by cpp) */
		if (ctx->TOKT->loc.soffs < nnew->loc.soffs) {
			for(n = ctx->TOKT; n->next != NULL; n = n->next) {
				if (n->next->loc.soffs >= nnew->loc.soffs)
					break;
			}
			del_start = n->next;
		}
		else {
			del_start = ctx->TOKT;
			ctx->TOKT = NULL;
		}

		/* free the rest of the nodes from del_start */
		if (del_start != NULL) {
/*			fprintf(stderr, "del\n");*/
//			C99Nfree(ctx, del_start);
		}
	
		if (ctx->TOKT == NULL)
			ctx->TOKT = nnew;
		else
			n->next = nnew;
	}
	else
		ctx->TOKT = nnew;

	return nnew;
}
